C     *************************************
C     *   DISPLAY RESULT OF CALCULATIONS  *
C     *************************************
C
      SUBROUTINE dspresul(ifile,
     $  connew,conf,cong,delta,rfact,wrfact,ents,entj,qfunc,
     $  IHIST,FHIST,mhist,nhist,iptyp,ncycl,
     $  mref,nrefF,nrefG,FOBS,FCAL,SIGF,
     $  PROF,NGRP,GOBS,GCAL,SIGG,IDX)
C
      implicit none
      integer mref,nrefF,nrefG
C     *** variables connected with the structure factors given as input:
C     *** FOBS: unique reflections, GOBS: groups of non-unique refl.
C     *** SIGF, SIGG are the sigma^2 of |Fobs| and Gobs.
      real*8 FOBS(2,mref),FCAL(2,mref),SIGF(mref),GCAL(mref),
     $    PROF(mref),GOBS(mref),SIGG(mref)
      integer IDX(3,mref),NGRP(mref),j,k,igrp,iref,jref
      integer ifile,iptyp,ncycl,jh,jk,jl
      real*8 connew,conf,cong,delta,rfact,wrfact,ents,entj,qfunc
     $   ,dev,fcpr,fcpi
C
C     *** variables connected with lambda-history list:
      integer mhist,nhist,IHIST(MHIST)
      real*8 FHIST(3,MHIST)
C
 3030 FORMAT( /' CON=',F16.7,' CONF=',F16.7,' CONG=',F16.7
     $        /'DELT=',F16.7,'    R=',F16.7,'   WR=',F16.7)
 3040 FORMAT(  'ENTS=',F16.7,' ENTJ=',F16.7,' LAGR=',F16.7)
 3050 FORMAT(//' *********   FINAL RESULT OF MEED ANALYSIS   *******',
     $       '*************************')
 3065 FORMAT(//' *********   HISTORY OF CHANGING LAMBDA  ***********',
     $       '*************************'/' ')
 3070 FORMAT(' CYCLE=',I5,
     +       ', LAMBDA=',F10.7,' --> ',F10.7,', CON=',F15.3)
C
C *** Title of Fobs-list with preferred orientation ***
C
 3080 FORMAT(//' *********   LIST OF STRUCTURE FACTORS   ***********',
     $ '*************************'//'   H   K   L ',5X,'FOBS',18X,
     $ 'FCAL*P',16X,'FCAL','                  dev.')
C
C *** Title of Fobs-list without preferred orientation ***
C
 3081 FORMAT(//' *********   LIST OF STRUCTURE FACTORS   ***********',
     $ '*************************'//'   H   K   L ',5X,'FOBS',18X,
     $ 'FCAL','                 dev.')
C                  hkl    Fobs  Fcal*p  Fcal  dev
 3090 FORMAT(' ',3(I3,1X),6F11.4,1X,f7.2)	!Fobs with preferred orientation
C                  hkl    Fobs  Fcal  dev
 3091 FORMAT(' ',3(I3,1X),4F11.4,1X,f7.2)	!Fobs without p.o.
C
C *** Title of Gobs-list ***
C
 3100 FORMAT(
     $  /'   H   K   L ',5X,'GOBS',9X,'GCAL',11X,'FCAL',18x,'dev.')
C *** for Gobs-list: first line of a group
C                 hkl     Gcal     Gobs     Fcal      dev
 3110 FORMAT(' ',3(I3,1X),F11.4,2X,F11.4,4X,2F11.4,2X,f7.2)
C *** for Gobs-list: following lines
C                 hkl        Fcal
 3115 FORMAT(' ',3(I3,1X),28X,2F11.4)

C 3120 FORMAT(/' *********   END OF MEED ANALYSIS  DATE ',2A4,'  TI',
C     $       'ME ',2A4,'   ***********',3(/' '))
 3120 FORMAT(/' *********   END OF MEED ANALYSIS   ***********')
C
      WRITE(ifile,3050)
      WRITE(ifile,3030) connew,conf,cong,delta,rfact,wrfact
      WRITE(ifile,3040) ents,entj,qfunc
      IF (nhist.NE.0) THEN
         WRITE(ifile,3065)
         WRITE(ifile,3070) (IHIST(J),(FHIST(K,J),K=1,3),J=1,nhist)
      END IF
      WRITE(ifile,'(a,i6)')' Number of cycles calculated:',ncycl
C
C     CALL DSPTIM(ifile,ITCYCL)
C
      if (iptyp.ge.0) then
        WRITE(ifile,3080)
      else
        write(ifile,3081)
      endif
      DO 80 iref=1,nrefF
         jh=IDX(1,iref)
         jk=IDX(2,iref)
         jl=IDX(3,iref)
         fcpr=FCAL(1,iref)*PROF(iref)
         fcpi=FCAL(2,iref)*PROF(iref)
	 dev=( sqrt( fcpr**2 + fcpi**2 ) - 
     $         sqrt( FOBS(1,iref)**2 + FOBS(2,iref)**2 )  
     $        )/sqrt(SIGF(iref))
	 if (iptyp.ge.0) then
C	   *** Fobs with preferred orientation ***
           WRITE(ifile,3090) jh,jk,jl,
     $       (FOBS(j,iref),j=1,2),fcpr,fcpi,
     +       (FCAL(j,iref),j=1,2), dev
	 else
C	   *** Fobs without p.o. ***
           WRITE(ifile,3091) JH,JK,JL,
     $       (FOBS(j,iref),j=1,2),
     $       (FCAL(j,iref),j=1,2), dev
	 endif  
   80 CONTINUE
      write(ifile,*) 
     $   'Relative deviation dev=(|Fcal|-|Fobs|)/sigma(|F|)'
      IF (nrefG.EQ.0) GO TO 270
      jref=iref-1
      WRITE(ifile,3100)
      DO 90 iref=1,nrefG
	 dev= ( GCAL(iref)-GOBS(iref) )/sqrt(SIGG(iref))
         DO 90 IGRP=1,NGRP(iref)
            jref=jref+1
            jh=IDX(1,jref)
            jk=IDX(2,jref)
            jl=IDX(3,jref)
            IF (igrp.EQ.1) THEN
               WRITE(ifile,3110)
     $         jh,jk,jl,GOBS(iref),GCAL(iref),
     $         (FCAL(j,jref),j=1,2), dev
            ELSE
               WRITE(ifile,3115) jh,jk,jl,(FCAL(j,jref),j=1,2)
            END IF
   90 continue
      write(ifile,*) 
     $   'Relative deviation dev=(Gcal-Gobs)/sigma(G)'
  270 WRITE(ifile,3120) 
      print *
      RETURN
      END
